
Unit ErrorMsg;

(*************************************************)
(* Provides descriptive run-time error messages. *)
(* Version 1.0                                   *)
(* by Sid Cave    mailto:zcave@yahoo.com         *)
(*************************************************)

interface
implementation

Var 
  OldExitProc: pointer;

Procedure ErrorMessage;
Begin
  Exitproc := OldExitProc;
  If ErrorAddr <> Nil Then
    Begin
      Case ExitCode Of
        1: writeln ('Invalid function number.');
        2: writeln ('File not found.');
        3: writeln ('Path not found.');
        4: writeln ('Too many open files.');
        5: writeln ('File access denied.');
        6: writeln ('Invalid file handle.');
        12: writeln ('Invalid file access code.');
        15: writeln ('Invalid drive number.');
        16: writeln ('Cannot remove current directory.');
        17: writeln ('Cannot rename across drives.');
        100: writeln ('Disk read error.');
        101: writeln ('Disk write error.');
        102: writeln ('File not assigned.');
        103: writeln ('File not open.');
        104: writeln ('File not open for input.');
        105: writeln ('File not open for output.');
        106: writeln ('Invalid numeric format.');
        150: writeln ('Disk is write-protected.');
        151: writeln ('Bad drive request struct length.');
        152: writeln ('Drive not ready.');
        154: writeln ('CRC error in data.');
        156: writeln ('Disk seek error.');
        157: writeln ('Unknown media type.');
        158: writeln ('Sector not found.');
        159: writeln ('Printer out of paper.');
        160: writeln ('Device write fault.');
        161: writeln ('Device read fault.');
        162: writeln ('Hardware failure.');
        200: writeln ('Division by zero.');
        201: writeln ('Range check error.');
        202: writeln ('Stack overflow error.');
        203: writeln ('Heap overflow error.');
        204: writeln ('Invalid pointer operation.');
        205: writeln ('Floating point overflow.');
        206: writeln ('Floating point underflow.');
        207: writeln ('Invalid floating point operation.');
        210: writeln ('Object not initialized.');
        211: writeln ('Call to abstract method.');
        212: writeln ('Stream registration error.');
        213: writeln ('Collection index out of range.');
        214: writeln ('Collection overflow error.');
        216: writeln ('General protection fault.');
        217: writeln ('Unhandled exception occurred.');
        227: writeln ('Assertion failed error.');
        Else writeln ('Unknown error.');
      End;
    End;
End;

Begin
  OldExitProc := ExitProc;
  ExitProc := @ErrorMessage;
End.
