{ Copyright (C) 2004 A.J. Venter

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
  Place - Suite 330, Boston, MA 02111-1307, USA.
}

{$H-}
unit libdireqcafe;


interface

uses
  Classes, SysUtils,oldlinux;

Const UserLoggedIn = 1;
         UserLoggedOut = 0;
         UserPaused = 2;
         UserNotActive = 3;
         UserKick = 4;
  
Type UserRec = Record
              time : Integer;
              Status: Integer;  {See Constants Above}
              name : ShortString;

     end;
     
     Configuration = Record
                   browser, editor, desktop, currency,price : ShortString;

     end;
     
     Transaction = Record
                 username : ShortString;
                 Date : TDateTime;
                 Ammount : ShortString;
                 Time : Integer;
     end;
     

     
Var MyConfig : Configuration;




Function ReadTransactions (startDate, EndDate:TdateTime; output : Integer):String;
Function IsActive (Username :ShortString) : Integer;
Procedure ActivateUser (Username : Shortstring);
Procedure AddUserTime (username : ShortString; Time : Integer);
Procedure CreateTickets (basename:String;start,num,time :Integer);
Procedure SaveSettings (config :configuration);
Procedure GetSettings (var config : Configuration);
Function GetUserTime (username:ShortString):Integer;
Function GetUserStatus(username:ShortString):Integer;
Procedure SetUserSTatus (Username:ShortString;Status:Integer);
Procedure SetUserTime (Username:ShortString;Time:Integer);

Function GetError :String;


implementation

Function ReadTransactions (startDate, EndDate:TdateTime; output : Integer):String;
Var F : File Of Transaction;
    T : Transaction;
       userName,ammount : AnsiString;
    TotalT,E : Integer;
    TotalP,X : Real;
    Grey : Boolean;
   OutF : Text;
    FileName :String;
    DateString:AnsiString;

Begin

Filename := '/tmp/direqcafe_transactions_'+DateToStr(StartDate)+'_'+DateToStr(EndDate);
If Output = 1 then FileName := FileName + '.html';
If Output = 2 then FileName := FileName + '.txt';
If output = 3 then FileName := FileName + '.csv';
If output = 4 then FileName := FileName + '.sql';

Assign(OutF,FileName);
rewrite (outF);

Assign (F,'/usr/share/direqcafe/accounts.dat');
reset (F);
Grey := True;

{Headers}
Case Output of
1: begin
       writeln (OutF,'<HTML>');
       writeln (OutF,'<HEAD>');
       writeln (OutF,'<TITLE>DireqCafe Transaction Log: '+DateToStr(StartDate)+' - '+DateToStr(EndDate)+' </TITLE>');
       writeln (OutF,'<BODY BGCOLOR=WHITE>');
       writeln (OutF,'<CENTER><H1>DireqCafe Transaction Log: '+DateToStr(StartDate)+' - '+DateToStr(EndDate)+'</H1></CENTER><BR><BR>');
       writeln (OutF,'<TABLE BORDER=3 WIDTH=80%');
       writeln (OutF,'<TR><TD BGCOLOR=GREEN>Username</TD><TD BGCOLOR=GREEN>Date:</TD><TD BGCOLOR=GREEN>Time Purchased:</TD><TD BGCOLOR=GREEN>Amount:</TD></TR>');
   end;

2: begin
      writeln (OutF,'DireqCafe Transaction Log: '+DateToStr(StartDate)+' - '+DateToStr(EndDate));
      Writeln (OutF);
      Writeln (OutF,'Username:     Date:     Time Purchased:     Amount:');
      writeln (OutF);
   end;

3: begin
      Writeln (OutF,'"Username:","Date:","Time Purchased:","Amount:","Total Time","Total Amount"');
   end;
end;{Case}

TotalT := 0;
TotalP := 0;

While not eof (F) do
Begin
read (F,T);
username := t.username;
ammount := t.ammount;
     If (T.Date >= startDate) And (T.Date <= EndDate) then
     Begin
     TotalT := TotalT + T.Time;
     Val (T.Ammount,X,E);
     TotalP := TotalP + X;
      Case Output Of
      1:Begin
        If Grey then
           Begin
 writeln (OutF,'<TR><TD>'+username+'</TD><TD>'+DateToStr(T.Date)+'</TD><TD>'+IntToStr(t.TIME)+'</TD><TD>'+MyConfig.Currency+Ammount+'</TD></TR>');
           Grey := False;
           end
        else
           Begin
           writeln (OutF,'<TR><TD BGCOLOR=GREY>'+username+'</TD><TD BGCOLOR=GREY>'+DateToStr(T.Date)+'</TD><TD BGCOLOR=GREY>'+IntToStr(t.TIME)+'</TD><TD BGCOLOR=GREY>'+MyConfig.Currency+Ammount+'</TD></TR>');
           Grey := True;;
           end;
        End; {1}
       2:Begin
           writeln (OutF,username+'     '+DateToStr(T.Date)+'     '+IntToStr(t.TIME)+'     '+MyConfig.Currency+Ammount);
         End; {2}
       3:Begin
           writeln (OutF,username+','+DateToStr(T.Date)+','+IntToStr(t.TIME)+','+MyConfig.Currency+Ammount,',,');
         End;{3}
       4:Begin
           DateTimeToString(DateString,'yyyy-mm-dd',T.Date);
           writeln (OutF,'INSERT INTO transactions VALUES("',username,'","',DateString,'","',IntToStr(t.TIME),'","',ammount,'");');
         end;
      end{Case}
     end{if}
end;{While}

Close (F);

 {Footers}
Case Output of
1: begin
       Writeln (outF,'<TR><TD COLSPAN=2 BGCOLOR=GREEN><B>Total:</B></TD><TD BGCOLOR=GREEN><B>',TotalT,'</B></TD><TD BGCOLOR=GREEN><B>',myconfig.currency,TotalP:10:2,'</B></TD></TR>');
       writeln (OutF,'</TABLE>');
       writeln (OutF,'</BODY>');
       writeln (OutF,'</HTML>');

   end;

2: begin
       Writeln (OutF);
       Writeln (outF,'Total Time:       ',TotalT);
       Writeln (OutF,'Total Ammount:    ',myconfig.currency,TotalP:10:2);
   end;

3: begin
       Writeln (OutF,',,,,',TotalT,',',myconfig.currency,TotalP:10:2);
   end;
end;{Case}

Close(OutF);
ReaDTranSactions := FileName;

end;




Function GetError : String;
Var F : Text;
    L : String;
Begin
Assign (F,'/tmp/error.msg');
reset (F);
readln (F,L);
close (F);
GetError := L;
end;

Procedure StoreTransaction (username: ShortString; ammount : Integer);
Var F : File Of Transaction;
    T : Transaction;
    X : Real;
    E : Integer;
    S :String;
begin

Assign (F,'/usr/share/direqcafe/accounts.dat');
reset (F);

seek (F,filesize(F));

T.username := username;
Val (MyConfig.Price,X,E);
X := X * ammount;
Str(X:10:2,S);
T.Ammount := S;
T.Time := Ammount;
T.Date := date;
write (F,T);
close (F);
end;



Function IsActive (Username :ShortString) : Integer;
Var F: File Of UserRec;
begin

assign (F,'/usr/share/direqcafe/db/'+username);
{$I-}
reset (F);
{$I+}
ISActive := IOResult;
{$I-}
//It was really dumb of me to leave this out initiallly, thanks Nick Hill for pointing it out.
close(F)
{$I+}
end;

Procedure ActivateUser (Username : Shortstring);
Var UF : File Of UserRec;
    U : UserRec;
begin
Assign (UF,'/usr/share/direqcafe/db/'+username);
rewrite (UF);
U.Time := 0;
U.Status := 0;
U.Name := UserName;
Write (UF,U);
close (UF);
shell ('chgrp icafe /usr/share/direqcafe/db/'+username);
shell ('chmod g+w /usr/share/direqcafe/db/'+username);
end;

Function GetUserTime (username :ShortString):Integer;
Var UF : File Of UserRec;
    U : UserRec;
Begin
Assign (UF,'/usr/share/direqcafe/db/'+username);
{$I-}
reset (UF);
read (UF,U);
{$I+}

If IOResult = 0 then
Begin
     GetUserTime := U.time;
end else
    GetUserTime := 0;
    
{$I-}
close(UF);
{$I+}
end;


Function GetUserStatus(username:ShortString):Integer;
Var UF : File Of UserRec;
    U : UserRec;
Begin
Assign (UF,'/usr/share/direqcafe/db/'+username);
{$I-}
reset (UF);
read (UF,U);
{$I+}
if IOResult = 0 then
Begin

      GetUserStatus := U.Status;
end else
	GetUserStatus := 0;
{$I-}
close(UF);
{$I+}
end;

Procedure SetUserSTatus (Username:ShortString;Status:Integer);
Var UF : File of UserRec;
    U  : UserRec;
Begin
Assign (UF,'/usr/share/direqcafe/db/'+username);
U.Time := GetUserTime (username);
U.Status := Status;
rewrite (UF);
write (UF,U);
close (UF);
end;

Procedure SetUserTime (Username:ShortString;Time:Integer);
{Note SetUserTime does not have any of the controls we put into addusertime or transaction storing}
{It is used by the counter}
Var UF : File of UserRec;
    U  : UserRec;
Begin
Assign (UF,'/usr/share/direqcafe/db/'+username);
U.Status := GetUserStatus (username);
U.Time := Time;
rewrite (UF);
write (UF,U);
close (UF);
end;

Procedure AddUserTime (username : ShortString; Time : Integer);
Var
NewTime : Integer;
UF : File Of UserRec;
U : UserRec;

begin

if IsActive (username) <> 0 then
  ActiVateUser(username);
    U.time := Time + GetUserTime (username);
   U.Status := GetUserStatus (UserName);

    {It is important to do this, so logged in users can still purchase time}

StoreTransaction (Username,Time);
       
Assign (UF,'/usr/share/direqcafe/db/'+username);
rewrite (UF);

Write (UF,U);
close (UF);

end;




Procedure CreateTickets (basename:String;start,num,time :Integer);
Var Good : boolean;
    X,Y : Integer;
    S,L :String;
    T:ShortString;
    F :Text;
    Price:Real;
begin
Val (MyConfig.Price,Price,X);
Price := Price * time;
Assign (F,'/tmp/tickets.html');
rewrite (F);
writeln (F,'<html><head><title>DireqCafe Tickets:</title></head>');
Writeln (F,'<body bgcolor=white><center><h1>DireqCafe Tickets</h1></center>');
For X := start to (start + num -1) do
begin
Str (x,S);
s := basename + S + chr(random(26) + 97 );

shell ('useradd  -m -G icafe '+S);
shell ('passwd -d '+S);
        AddUserTime(S,time);
        writeln (F,'<table width=80% border=3><tr><td>',S,'</td><td width=10% align=right>',getUserTime(S),'</td><td width=10%>',MyConfig.currency,price:5:2,'</td></tr></table><br><BR>');

end;
close (F);
end;

Procedure SaveSettings (config : Configuration);
Var SettingsFile : File Of Configuration;
begin
  Assign (SettingsFile,'/usr/share/direqcafe/settings.cfg');
  rewrite (SettingsFile);
  write (SettingsFile,Config);
  close (SettingsFile);
end;


Procedure GetSettings (var config : Configuration);
Var SettingsFile : File Of Configuration;

begin
    Assign (SettingsFile,'/usr/share/direqcafe/settings.cfg');
{$I-}
    Reset (SettingsFile);
{$I+}
 If IOResult <> 0 then
        begin
             rewrite (SettingsFile);
             config.browser := 'konqueror';
             config.desktop := 'kicker';
             config.editor := 'kwrite';
             config.currency := '$';
             config.price := '1.00';
             write (SettingsFile,Config);
             Close (SettingsFile);
             shell ('chgrp icafe  /usr/share/direqcafe/settings.cfg');
             shell ('chmod g+w /usr/share/direqcafe/settings.cfg');
             Reset(SettingsFile);
        end;
read (SettingsFile,Config);
close (SettingsFile);


end;



end.

